# all files / Github/diagram-js/lib/layout/ LayoutUtil.js

100% Statements 43/43
95.56% Branches 43/45
100% Functions 10/10
100% Lines 43/43

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208

    10×

    10012×

    4185×

    63×

    7950×

    1408×

    1408×
    1329×

    1408×
    1408×

    1408×
    1408×
    1408×
    1408×

    1408×
    1408×

    1408×
    320×

    1088×

    1666×

    1666×
    1423×
    243×
    154×
    89×

    31×
    66×

    66×

    66×

    66×

    31×

    58×

    1666×

    20×

    20×

    20×
    71×
    71×
    71×

    71×

    2×

    69×

    20×

     import {
      isObject,
      sortBy
    } from 'min-dash';

    import {
      pointDistance,
      pointsOnLine
    } from '../util/Geometry';

    import intersectPaths from 'path-intersection';

    export function roundBounds(bounds) {
      return {
        x: Math.round(bounds.x),
        y: Math.round(bounds.y),
        width: Math.round(bounds.width),
        height: Math.round(bounds.height)
      };
    }

    export function roundPoint(point) {

      return {
        x: Math.round(point.x),
        y: Math.round(point.y)
      };
    }

    /**
     * Convert the given bounds to a { top, left, bottom, right } descriptor.
     *
     * @param {Bounds|Point} bounds
     *
     * @return {Object}
     */
    export function asTRBL(bounds) {
      return {
        top: bounds.y,
        right: bounds.x + (bounds.width || 0),
        bottom: bounds.y + (bounds.height || 0),
        left: bounds.x
      };
    }

    /**
     * Convert a { top, left, bottom, right } to an objects bounds.
     *
     * @param {Object} trbl
     *
     * @return {Bounds}
     */
    export function asBounds(trbl) {
      return {
        x: trbl.left,
        y: trbl.top,
        width: trbl.right - trbl.left,
        height: trbl.bottom - trbl.top
      };
    }

    /**
     * Get the mid of the given bounds or point.
     *
     * @param {Bounds|Point} bounds
     *
     * @return {Point}
     */
    export function getMid(bounds) {
      return roundPoint({
        x: bounds.x + (bounds.width || 0) / 2,
        y: bounds.y + (bounds.height || 0) / 2
      });
    }

    // orientation utils //////////////////////

    /**
     * Get orientation of the given rectangle with respect to
     * the reference rectangle.
     *
     * A padding (positive or negative) may be passed to influence
     * horizontal / vertical orientation and intersection.
     *
     * @param {Bounds} rect
     * @param {Bounds} reference
     * @param {Point|Number} padding
     *
     * @return {String} the orientation; one of top, top-left, left, ..., bottom, right or intersect.
     */
    export function getOrientation(rect, reference, padding) {

      padding = padding || 0;

      // make sure we can use an object, too
      // for individual { x, y } padding
      if (!isObject(padding)) {
        padding = { x: padding, y: padding };
      }

      var rectOrientation = asTRBL(rect),
          referenceOrientation = asTRBL(reference);

      var top = rectOrientation.bottom + padding.y <= referenceOrientation.top,
          right = rectOrientation.left - padding.x >= referenceOrientation.right,
          bottom = rectOrientation.top - padding.y >= referenceOrientation.bottom,
          left = rectOrientation.right + padding.x <= referenceOrientation.left;

      var vertical = top ? 'top' : (bottom ? 'bottom' : null),
          horizontal = left ? 'left' : (right ? 'right' : null);

      if (horizontal && vertical) {
        return vertical + '-' + horizontal;
      } else {
        return horizontal || vertical || 'intersect';
      }
    }

    // intersection utils //////////////////////

    /**
     * Get intersection between an element and a line path.
     *
     * @param {PathDef} elementPath
     * @param {PathDef} linePath
     * @param {Boolean} cropStart crop from start or end
     *
     * @return {Point}
     */
    export function getElementLineIntersection(elementPath, linePath, cropStart) {

      var intersections = getIntersections(elementPath, linePath);

      // recognize intersections
      // only one -> choose
      // two close together -> choose first
      // two or more distinct -> pull out appropriate one
      // none -> ok (fallback to point itself)
      if (intersections.length === 1) {
        return roundPoint(intersections[0]);
      } else if (intersections.length === 2 && pointDistance(intersections[0], intersections[1]) < 1) {
        return roundPoint(intersections[0]);
      } else if (intersections.length > 1) {

        // sort by intersections based on connection segment +
        // distance from start
        intersections = sortBy(intersections, function(i) {
          var distance = Math.floor(i.t2 * 100) || 1;

          distance = 100 - distance;

          distance = (distance < 10 ? '0' : '') + distance;

          // create a sort string that makes sure we sort
          // line segment ASC + line segment position DESC (for cropStart)
          // line segment ASC + line segment position ASC (for cropEnd)
          return i.segment2 + '#' + distance;
        });

        return roundPoint(intersections[cropStart ? 0 : intersections.length - 1]);
      }

      return null;
    }

    export function getIntersections(a, b) {
      return intersectPaths(a, b);
    }

    export function filterRedundantWaypoints(waypoints) {

      // alter copy of waypoints, not original
      waypoints = waypoints.slice();

      var idx = 0,
          point,
          previousPoint,
          nextPoint;

      while (waypoints[idx]) {
        point = waypoints[idx];
        previousPoint = waypoints[idx - 1];
        nextPoint = waypoints[idx + 1];

        if (pointDistance(point, nextPoint) === 0 ||
            pointsOnLine(previousPoint, nextPoint, point)) {

          // remove point, if overlapping with {nextPoint}
          // or on line with {previousPoint} -> {point} -> {nextPoint}
          waypoints.splice(idx, 1);
        } else {
          idx++;
        }
      }

      return waypoints;
    }